<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: BugReporter.php 3327 2005-06-09 15:11:22Z andrew $
*/

require_once MAX_PATH . '/lib/max/DB.php';
require_once MAX_PATH . '/lib/max/Emailer.php';

class MAX_BugReporter
{
    var $_clientInfo = array();
    var $_serverInfo = array();
    
    function MAX_BugReporter()
    {
        $this->_clientInfo = $this->getClientInfo();
        $this->_serverInfo = $this->getServerInfo();
        $this->_userInfo = $this->getCurrentUserInfo();
    }

    function getServerInfo()
    {
        $aServerInfo = array();
        //  get db info
        $dbh = & MAX_DB::singleton();
        $lastQuery = $dbh['last_query'];
        $aServerInfo['lastSql'] = isset($dbh['last_query']) ? 
            $dbh['last_query'] : null;
        $aServerInfo['phpSapi'] = php_sapi_name();
        $aServerInfo['phpOs'] = PHP_OS;
        $aServerInfo['dbType'] = phpAds_dbmsname;
        $aServerInfo['phpVersion'] = PHP_VERSION;
        $aServerInfo['serverPort'] = $_SERVER['SERVER_PORT'];
        $aServerInfo['serverSoftware'] = $_SERVER['SERVER_SOFTWARE'];   
        $aServerInfo['maxVersion'] = MAX_VERSION_READABLE;
        return $aServerInfo;
    }
    
    
    function getClientInfo()
    {
        $aclientInfo = array();
        $aclientInfo['callingURL'] = $_SERVER['SCRIPT_NAME'];
        $aclientInfo['httpReferer'] = $_SERVER['HTTP_REFERER'];
        $aclientInfo['httpUserAgent'] = $_SERVER['HTTP_USER_AGENT'];
        $aclientInfo['remoteAddr'] = $_SERVER['REMOTE_ADDR'];
        return $aclientInfo;
    }
    
    function getCurrentUserInfo()
    {
        // not implemented
    }
    
    function buildEnvironmentReport()
    {
        $html = '';
        $data = array_merge($this->_clientInfo, $this->_serverInfo);
        foreach ($data as $k => $v) {
            $html .= "[$k] => $v \n";   
        }
        return $html;
    }
    
    function buildEmail($oData)
    {
        $body = "The following bug report was submitted: \n\n";
        
        $options = array(
            'toEmail'       => '',
            'toRealName'    => '',
            'fromEmail'     => '',
            'fromRealName'  => '',
            'replyTo'       => '',
            'subject'       => 'Bug report',
            'body'          => $oData->toString(),
            'template'      => '',
            'username'      => '',
            'siteUrl'       => SGL_BASE_URL,
            'siteName'      => 'Max Media Manager',
            'crlf'          => ''
        );
        $email = new Max_Emailer($options);
        $ret = $email->prepare();
        if (PEAR::isError($email)) {
            //  die silently and log   
        } else {
            return $email;
        }
    }
}

class MAX_BugReport
{
    var $_data = null;
    
    function MAX_BugReport($oData)
    {
        foreach ($oData as $k => $v) {
            $this->$k = $v;   
        }
    }
    
    function getEmail()
    {
        
    }
    
    function getName()
    {
        
    }
    
    function toString()
    {
        $reportHtml = '';   
    }
}
?>